// C Header File
// Created 21/01/2003; 00:22:44

#ifndef __complib__
#define __complib__

/*===============================================================================================
== code des erreurs renvoyer par les fonctiona travers le parametre pb
=================================================================================================
== si pb<0, on a echoue : pas de creation de var
        >0, creation de var, mais y'a un probleme
        =0 : pas de probleme
===============================================================================================*/
 
#define COMP_NO_ERR           0  //pas de probleme
#define COMP_ERR_MEM         -1  //erreur de mmoire
#define COMP_ERR_CANT_ADD    -2  //impossible d'ajouter la variable
#define COMP_ERR_NO_SRC_VAR  -3  //variable source inexitante
#define COMP_ERR_NOT_A_COMP  -4  //la variable n'est pas compresse
#define COMP_ERR_WRONG_TYPE  -5  //il faut imprativement donner un type  la variable et un nom
#define COMP_ERR_CANT_COMP   -6  //le fichier compress est plus gros que l'original
#define COMP_ERR_CANT_REARCH  1  //la variable ne peut etre rearchiver

/*===============================================================================================
== Normalement, vous n'avez pas  utiliser ces 4 fonctions, elles sont juste la pour pouvoir
definir des define plus loin...
===============================================================================================*/
extern HANDLE mk_zip(unsigned char * data, unsigned short longueur, unsigned char type, BOOL temp, char * pb);
extern HANDLE mk_dzip(unsigned char * data, unsigned short longueur, const char * str_tag, unsigned char tag_length, char * pb);
extern HANDLE mk_komp(unsigned char *data, unsigned short longueur, unsigned char type, BOOL temp, char * pb);
extern HANDLE mk_dkomp(unsigned char * data, unsigned short longueur, const char * str_tag, unsigned char tag_length, char * pb);


/*===============================================================================================
=================================================================================================
== Dans toute les fontions proposs ci-dessous, il y a le choix entre la version zip et komp   ==
== Pour le dcompression, les versions comp s'occupent de tous les formats gr par cette lib  ==
=================================================================================================
===============================================================================================*/


/*===============================================================================================
== Compression de donne dans un handle temporaire
=================================================================================================
== data : pointeur des donnes  dcompresser
== longueur : longueur des donnes  dcompresser
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes compresses
===============================================================================================*/
#define zip_data_temp(data,longueur,pb)							mk_zip(data,15,longueur,TRUE,pb)
#define komp_data_temp(data,longueur,pb)						mk_komp(data,longueur,TRUE,pb)

/*===============================================================================================
== Compression de donne dans une variable
=================================================================================================
== data : pointeur des donnes  dcompresser
== longueur : longueur des donnes  dcompresser
== nom_var_dest : nom de la variable dans laquelle on doit dcompresser
== str_tag : tag  ajouter  la fin
== tag_length : longueur du tag (ne se termine pas par 0! impossible d'utiliser strlen)
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le pointeur Sym de la variable cre
===============================================================================================*/
extern SYM_ENTRY * zip_data_var(unsigned char *data, unsigned short longueur, const char * nom_var, char * pb);
extern SYM_ENTRY * komp_data_var(unsigned char *data, unsigned short longueur, const char * nom_var, char * pb);

/*===============================================================================================
== Compression d'une variable dans un handle temporaire
=================================================================================================
== sym_var_src : pointeur sym de la var  compresser
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes compresses
===============================================================================================*/
extern HANDLE zip_sym_temp(SYM_ENTRY * sym_var_src, char * pb);
extern HANDLE komp_sym_temp(SYM_ENTRY * sym_var_src, char * pb);

/*===============================================================================================
== Compression d'une variable dans une autre variable
=================================================================================================
== sym_var_src : pointeur sym de la var  compresser
== nom_var_dest : nom de la variable dans laquelle on compresse
									si vaut NULL, compresse dans la variable de dpart
== str_tag : tag  ajouter  la fin
== tag_length : longueur du tag (ne se termine pas par 0! impossible d'utiliser strlen)
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie pointeur Sym de la nouvelle variable
===============================================================================================*/
extern SYM_ENTRY * zip_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb);
extern SYM_ENTRY * komp_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb);


//#define zip_var_temp(nom_var,pb)											zip_sym_temp(DerefSym(SymFind(SYMSTR(nom_var))),pb)
//#define komp_var_temp(nom_var,pb)										komp_sym_temp(DerefSym(SymFind(SYMSTR(nom_var))),pb)

//#define zip_var_var(nom_var_src,nom_var_dest,pb)			zip_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),nom_var_dest,pb)
//#define komp_var_var(nom_var_src,nom_var_dest,pb)		komp_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),nom_var_dest,pb)


/*===============================================================================================
== Dcompression de donne dans un handle temporaire
=================================================================================================
== data : pointeur des donnes  dcompresser
== longueur : longueur des donnes  dcompresser
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes dcompresses
===============================================================================================*/
#define dzip_data_temp(data,longueur,pb)					  mk_dzip(data,longueur,NULL,0,pb)
#define dkomp_data_temp(data,longueur,pb)						mk_dkomp(data,longueur,NULL,0,pb)
extern HANDLE dcomp_data_temp(unsigned char * data, unsigned short longueur, char * pb);


/*===============================================================================================
== Dcompression ziplib de donne dans une variable
=================================================================================================
== data : pointeur des donnes  dcompresser
== longueur : longueur des donnes  dcompresser
== nom_var_dest : nom de la variable dans laquelle on doit dcompresser
== str_tag : tag  ajouter  la fin
== tag_length : longueur du tag (ne se termine pas par 0! impossible d'utiliser strlen)
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le pointeur Sym de la variable cre
===============================================================================================*/
extern SYM_ENTRY * dzip_data_var(unsigned char * data, unsigned short longueur, const char * nom_var_dest, const char * str_tag, unsigned char tag_length, char * pb);
extern SYM_ENTRY * dkomp_data_var(unsigned char * data, unsigned short longueur, const char * nom_var_dest, const char * str_tag, unsigned char tag_length, char * pb);
extern SYM_ENTRY * dcomp_data_var(unsigned char * data, unsigned short longueur, const char * nom_var_dest, const char * str_tag, unsigned char tag_length, char * pb);

/*===============================================================================================
== Dcompression ziplib d'une variable dans un handle temporaire
=================================================================================================
== sym_var_src : pointeur sym de la var  dcompresser
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes dcompresses
===============================================================================================*/
extern HANDLE dzip_sym_temp(SYM_ENTRY * sym_var_src, char * pb);
extern HANDLE dkomp_sym_temp(SYM_ENTRY * sym_var_src, char * pb);
extern HANDLE dcomp_sym_temp(SYM_ENTRY * sym_var_src, char * pb);


/*===============================================================================================
== Dcompression ziplib d'une variable dans une variable
=================================================================================================
== sym_var_src : pointeur sym de la var  dcompresser
== nom_var_dest : nom de la variable dans laquelle on dcompresse
									si vaut NULL, dcompresse dans la variable de dpart
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le pointeur Sym de la nouvelle variable
===============================================================================================*/
extern SYM_ENTRY * dzip_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb);
extern SYM_ENTRY * dkomp_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb);
extern SYM_ENTRY * dcomp_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb);


//#define dzip_var_temp(nom_var,pb)										dzip_sym_temp(DerefSym(SymFind(SYMSTR(nom_var))),pb)
//#define dkomp_var_temp(nom_var,pb)										dkomp_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),pb)

//#define dzip_var_var(nom_var_src,nom_var_dest,pb)		dzip_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),nom_var_dest,pb)
//#define dkomp_var_var(nom_var_src,nom_var_dest,pb)		dkomp_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),nom_var_dest,pb)


/*===============================================================================================
== types de compression renvoy par les fonctions get_type
===============================================================================================*/
#define COMP_TYPE_NORMAL  0
#define COMP_TYPE_ZIPLIB  1
#define COMP_TYPE_KOMP    2

/*===============================================================================================
== Donne le type complet de la variable
=================================================================================================
== data : pointeur vers le l'adresse des donnes de la variable
=================================================================================================
== renvoie le type de la variable dans l'octet du bas
           le type de compression dans l'octet du haut
===============================================================================================*/
extern unsigned short get_type(unsigned char * data);

/*===============================================================================================
== plusieurs macros pour connaitre le type de la variable  partir du type donn par get_type
=================================================================================================
== is_compressed revoie TRUE si le type est du type compress en ziplib ou komp
=================================================================================================
== is_compressed_ziplib revoie TRUE si le type est du type compress en ziplib
=================================================================================================
== is_compressed_komp revoie TRUE si le type est du type compress en komp
=================================================================================================
== get_type_initial_var renvoie le type selon de la variable dcompresse (si non-compresse,
renvoie simplement son type
===============================================================================================*/
#define is_compressed(comp_type)            ((comp_type&0x00FF)!=0)
#define is_compressed_ziplib(comp_type)     ((comp_type&0x00FF)==1)
#define is_compressed_komp(comp_type)       ((comp_type&0x00FF)==2)
#define get_compress_type(comp_type)        (comp_type&0x00FF)
#define get_type_initial_var(comp_type)     (comp_type>>8)

/*===============================================================================================
== Donne le type complet de la variable
=================================================================================================
== SymPtr : pointeur sym vers la variable
=================================================================================================
== renvoie le type de la variable dans l'octet du bas
           le type de compression dans l'octet du haut
===============================================================================================*/
#define get_type_sym(SymPtr)     get_type(HeapDeref(SymPtr->handle))

/*===============================================================================================
== Donne le type de compression de la variable
=================================================================================================
== SymPtr : pointeur sym vers la variable
=================================================================================================
== renvoie le type de compression
===============================================================================================*/
extern unsigned char get_type_comp_sym(SYM_ENTRY * SymPtr);

/*===============================================================================================
== Donne le type de la variable dcompresse, les cas echant le type de la variable elle-mme
=================================================================================================
== SymPtr : pointeur sym vers la variable
=================================================================================================
== renvoie le type de la variable
===============================================================================================*/
extern unsigned char get_type_initial_var_sym(SYM_ENTRY * SymPtr);

/*===============================================================================================
== Donne le type de compression de la variable en mode "texte"
=================================================================================================
== SymPtr : pointeur sym vers la variable
=================================================================================================
== renvoie le type & ' '  si variable normale
           le type & 'K' si variable compresse avec komp
           le type & 'Z' si variable compresse avec ziplib
           types donns sous forme texte :
           
===============================================================================================*/
extern unsigned short get_type_txt(SYM_ENTRY * SymPtr);

#endif
