// C Source File
// Created 15/04/2003; 11:18:14

#define _GENERIC_ARCHIVE
#define NO_CALC_DETECT
#include <tigcclib.h>
#include "complib.h"

/*===============================================================================================
== Dcompression de donne dans un handle temporaire
=================================================================================================
== data : pointeur des donnes  dcompresser
== longueur : longueur des donnes  dcompresser
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes dcompresses
===============================================================================================*/

HANDLE dcomp_data_temp(unsigned char * data, unsigned short longueur, char * pb) {
  
  unsigned short type=get_type(data);
  
  switch (get_compress_type(type)) {
  	case COMP_TYPE_NORMAL:
  	  return H_NULL;
  	case COMP_TYPE_ZIPLIB:
  	  return dzip_data_temp(data, longueur, pb);
  	case COMP_TYPE_KOMP:
  	  return dkomp_data_temp(data, longueur, pb);
  }

  return H_NULL;

}

/*===============================================================================================
== Dcompression de donne dans une variable
=================================================================================================
== data : pointeur des donnes  dcompresser
== longueur : longueur des donnes  dcompresser
== nom_var_dest : nom de la variable dans laquelle on doit dcompresser
== str_tag : tag  ajouter  la fin
== tag_length : longueur du tag (ne se termine pas par 0! impossible d'utiliser strlen)
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le pointeur Sym de la variable cre
===============================================================================================*/
SYM_ENTRY * dcomp_data_var(unsigned char * data, unsigned short longueur, const char * nom_var_dest, const char * str_tag, unsigned char tag_length, char * pb) {
  
  unsigned short type=get_type(data);
  
  switch (get_compress_type(type)) {
  	case COMP_TYPE_NORMAL:
  	  return NULL;
  	case COMP_TYPE_ZIPLIB:
  	  return dzip_data_var(data, longueur, nom_var_dest, str_tag, tag_length, pb);
  	case COMP_TYPE_KOMP:
  	  return dkomp_data_var(data, longueur, nom_var_dest, str_tag, tag_length, pb);
  }
  return NULL;
}

/*===============================================================================================
== Dcompression d'une variable dans un handle temporaire
=================================================================================================
== sym_var_src : pointeur sym de la var  dcompresser
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes dcompresses
===============================================================================================*/
HANDLE dcomp_sym_temp(SYM_ENTRY * sym_var_src, char * pb) {

  unsigned short type=get_type_sym(sym_var_src);
  
  switch (get_compress_type(type)) {
  	case COMP_TYPE_NORMAL:
  	  return H_NULL;
  	case COMP_TYPE_ZIPLIB:
  	  return dzip_sym_temp(sym_var_src, pb);
  	case COMP_TYPE_KOMP:
  	  return dkomp_sym_temp(sym_var_src, pb);
  }
  return H_NULL;

}

/*===============================================================================================
== Dcompression d'une variable dans une variable
=================================================================================================
== sym_var_src : pointeur sym de la var  dcompresser
== nom_var_dest : nom de la variable dans laquelle on dcompresse
									si vaut NULL, dcompresse dans la variable de dpart
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le pointeur Sym de la nouvelle variable
===============================================================================================*/
SYM_ENTRY * dcomp_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb) {

  unsigned short type=get_type_sym(sym_var_src);
  
  switch (get_compress_type(type)) {
  	case COMP_TYPE_NORMAL:
  	  return NULL;
  	case COMP_TYPE_ZIPLIB:
  	  return dzip_sym_var(sym_var_src, nom_var_dest, pb);
  	case COMP_TYPE_KOMP:
  	  return dkomp_sym_var(sym_var_src, nom_var_dest, pb);
  }
  return NULL;

}