// C Source File
// Created 14/04/2003; 20:58:44

#define _GENERIC_ARCHIVE
#define NO_CALC_DETECT
#include "complib_types.h"
#include <tigcclib.h>

/*===============================================================================================
== Cration des stats des caractres
=================================================================================================
== stat : tableau des stats  remplir
== data : adresse du debut des donnes
== longueur : longueur de donnes  traiter
=================================================================================================
== renvoie le nombre de caractres diffrents
===============================================================================================*/

unsigned char creation_stat(unsigned short stat[256], unsigned char * data, unsigned short longueur) {

		unsigned char nL=0;
		
		memset(stat,0,256*sizeof(unsigned short));

		while (longueur--!=0)
				if ((stat[*(data++)]++)==0)
						nL++;  //compte des caractres diffrents

		return nL;
}

/*===============================================================================================
== Tri des stats pour la cration de l'arbre
=================================================================================================
== stat : tableau des stats rempli
== noeud : tableau de noeuds  remplir
===============================================================================================*/

void tri_stat(unsigned short stat[256], NOEUD noeud[256]) {

		unsigned short i;
		unsigned short j=0;  //variables de boucle
		unsigned short min;  //valeur du plus petit
		unsigned char  p=0;  //position du plus petit
		unsigned short temp1;
		unsigned char  temp2;

		for (j=0;j<256;j++) {  //remplissage du tableau de noeud
				noeud[j].freq=stat[j];
				noeud[j].noeud=0;
				noeud[j].caract=j;
		}	

		for (j=0;j<255;j++) { //255 noeuds  faire max
				min=65535;
				for (i=j;i<256;i++) {
						if (noeud[i].freq<min && noeud[i].freq!=0) {
								min=noeud[i].freq;
								p=i;
						}
				}
				if (min==65535)
						break;
				temp1=noeud[j].freq;
				temp2=noeud[j].caract;
				noeud[j].freq=noeud[p].freq;
				noeud[j].caract=noeud[p].caract;
				noeud[p].freq=temp1;
				noeud[p].caract=temp2;
		}
}

/*===============================================================================================
== Cration de l'arbre  partir des stats tries
=================================================================================================
== noeud : tableau de noeuds rempli
== arbre : arbre  remplir
== nL : nombre de caractres diffrents (directement li  la longueur de l'arbre)
===============================================================================================*/

void creation_arbre(NOEUD noeud[256], ARBRE * arbre, unsigned char nL) {
		unsigned char j=0;
		unsigned char i;
		unsigned short freq;

		do {
				freq=noeud[j].freq;  //on prend les deux moins frequents
				if (noeud[j].noeud==1) {  //le premier est un noeud
						arbre[j].noeud_droit=1;
						arbre[noeud[j].caract].noeud_pere=j;
				}
				arbre[j].caract_droit=noeud[j].caract;
				freq+=noeud[++j].freq;//on prend le deuxime
				if (noeud[j].noeud==1) {
							arbre[j-1].noeud_gauche=1;
							arbre[noeud[j].caract].noeud_pere=j-1;
				}
				arbre[j-1].caract_gauche=noeud[j].caract;
				
				//on range...
				i=j;
				while (freq>=noeud[i+1].freq && i+1<nL) {
					//	*((long *)(&(noeud[i].freq)))=*((long *)(&(noeud[i+1].freq)));
						noeud[i].freq=noeud[i+1].freq;
						noeud[i].caract=noeud[i+1].caract;
						noeud[i].noeud=noeud[i+1].noeud;
						i++;
				}
				noeud[i].freq=freq;
				noeud[i].noeud=1;
				noeud[i].caract=j-1;
		} while (j<nL-1);
}

/*===============================================================================================
== Evalue la longueur en bit des donnes compresses
=================================================================================================
== data : adresse du dbut de l'arbre compress
== arbre : arbre de Huffmann
== stat : tableau de stat des caractres
=================================================================================================
== renvoie la longueur totale en bit
===============================================================================================*/

unsigned long eval_long(ARBRE * arbre, unsigned short stat[256]) {
		unsigned long longueur=0;
		unsigned char j=0;
		unsigned char i;
		unsigned char l;

		do {
				if (stat[j]==0)
						continue;  //caractre inexistant
				i=0;
				while ( ( arbre[i].caract_droit!=j || arbre[i].noeud_droit ) && ( arbre[i].caract_gauche!=j || arbre[i].noeud_gauche ) )
						i++;  //recherche du caractre dans l'arbre
				l=1;
				while ((i=arbre[i].noeud_pere)!=0) {
						l++;  //calcul de sa longueur
				}
				longueur+=l*stat[j];
		} while ((j++)!=255);
		
		return longueur;
}


/*===============================================================================================
== Ecriture des donnes compresse
=================================================================================================
== data : adresse des donnes  compresser
== longueur : longueur  compresser
== arbre : arbre de Huffmann pour la compression
== dest_fin : adresse de fin de la o on doit compresser les donnes
=================================================================================================
== renvoie 0 si y'a un pb de mmoire
           1 sinon
===============================================================================================*/

unsigned char ecriture_comp(unsigned char * data, unsigned short longueur, ARBRE * arbre,
														unsigned char * dest_fin, unsigned char decal) {
		struct CODE {
				unsigned char * ptr;
				unsigned char longueur;
				unsigned char decal;
		} * code;

		unsigned char j;
		unsigned char i;
		unsigned char * pos=data+longueur;  //on commence par le dernier caractre
		unsigned char noeud;
		unsigned char l;
		unsigned char * ptr;
		unsigned char decal2;

		code=(struct CODE *)malloc(256*sizeof(struct CODE));
		if (code==NULL)
				return 0;

		memset(code,0,256*sizeof(struct CODE));
		*dest_fin=0;
		
		while (data!=pos--) {  //tant qu'on est pas arriv  la fin
				if (code[*pos].longueur==0) {  //code  crer
						code[*pos].ptr=dest_fin;  //on mmorise les valeurs
						code[*pos].decal=decal;
						//recherche du code
						i=0;
						while ( ( arbre[i].caract_droit!=*pos || arbre[i].noeud_droit ) && ( arbre[i].caract_gauche!=*pos || arbre[i].noeud_gauche ) )
								i++;  //recherche du caractre
						if (*pos==arbre[i].caract_gauche && !arbre[i].noeud_gauche)
								*dest_fin|=(1<<decal);  //on est dans la branche de gauche : 1 (0 sinon)

						if ((decal--)==0) {
								decal=7;
								*(--dest_fin)=0;  //on efface
						}
						l=1;  //calcul de la longueur
						while ((i=arbre[noeud=i].noeud_pere)!=0) { //on remonte l'arbre
								l++;
								if (noeud==arbre[i].caract_gauche && arbre[i].noeud_gauche)
										*dest_fin|=(1<<decal);  //on est dans la branche de gauche : 1 (0 sinon)
								if ((decal--)==0) {
										decal=7;
										*(--dest_fin)=0;  //on efface
								}
						} 
						code[*pos].longueur=l;

				} else {  //on a dj coder ce caractre
						ptr=code[*pos].ptr;
						decal2=code[*pos].decal;
						for (j=code[*pos].longueur;j>0;j--) {  //copie du code
								if ((*ptr)&(1<<decal2))
										*dest_fin|=(1<<decal);
								if ((decal--)==0) {
										decal=7;
										*(--dest_fin)=0;  //on efface
								}
								if ((decal2--)==0) {
										decal2=7;
										ptr--;
								}
						}
				}
		}

		free(code);
		return 1;
}

/*===============================================================================================
== Ecriture des donnes dcompresse
=================================================================================================
== data : adresse des donnes  dcompresser
== longueur : longueur  dcompresser
== data_dest : adresse de dcompression de donnes
== arbre : arbre de Huffmann
== decal : dcalage (en bit) du dbut (+1)
== racine : emplacement de la racine dans l'arbre
=================================================================================================
== renvoie l'adresse de fin des donnes dcompresses
===============================================================================================*/

unsigned char * ecriture_decomp(unsigned char * data, unsigned short longueur, unsigned char * data_dest,
																ARBRE * arbre, unsigned char decal, unsigned char racine) {
		unsigned short no;

		decal--;
		while ((longueur--)>0) {
				no=racine;
arbre:
				if ((decal++)==7) {
						decal=0;
						data++;
				}
				if ((*data)&(1<<decal)) {  //1 : gauche
						if (arbre[no].noeud_gauche) { //1 : c'est un noeud, 0 : caractre
								no=arbre[no].caract_gauche;
						} else {
								*(data_dest++)=arbre[no].caract_gauche;  //ecriture
								continue;
						}
				} else {  //a droite...
						if (arbre[no].noeud_droit) { //noeud
								no=arbre[no].caract_droit;
						} else {
								*(data_dest++)=arbre[no].caract_droit;
								continue;
						}
				}
				goto arbre;
		}
		
		return data_dest;
		
}
