// C Header File
// Created 14/04/2003; 21:10:08

/*===============================================================================================
== Cration des stats des caractres
=================================================================================================
== stat : tableau des stats  remplir
== data : adresse du debut des donnes
== longueur : longueur de donnes  traiter
=================================================================================================
== renvoie le nombre de caractres diffrents
===============================================================================================*/

extern unsigned char creation_stat(unsigned short stat[256], unsigned char * data, unsigned short longueur);

/*===============================================================================================
== Tri des stats pour la cration de l'arbre
=================================================================================================
== stat : tableau des stats rempli
== noeud : tableau de noeuds  remplir
===============================================================================================*/

extern void tri_stat(unsigned short stat[256], NOEUD noeud[256]);

/*===============================================================================================
== Cration de l'arbre  partir des stats tries
=================================================================================================
== noeud : tableau de noeuds rempli
== arbre : arbre  remplir
== nL : nombre de caractres diffrents (directement li  la longueur de l'arbre)
===============================================================================================*/

extern void creation_arbre(NOEUD noeud[256], ARBRE * arbre, unsigned char nL);

/*===============================================================================================
== Evalue la longueur en bit des donnes compresses
=================================================================================================
== data : adresse du dbut de l'arbre compress
== arbre : arbre de Huffmann
== stat : tableau de stat des caractres
=================================================================================================
== renvoie la longueur totale en bit
===============================================================================================*/

extern unsigned long eval_long(ARBRE * arbre, unsigned short stat[256]);


/*===============================================================================================
== Ecriture des donnes compresse
=================================================================================================
== data : adresse des donnes  compresser
== longueur : longueur  compresser
== arbre : arbre de Huffmann pour la compression
== dest_fin : adresse de fin de la o on doit compresser les donnes
=================================================================================================
== renvoie 0 si y'a un pb de mmoire
           1 sinon
===============================================================================================*/

extern unsigned char ecriture_comp(unsigned char * data, unsigned short longueur, ARBRE * arbre,
														unsigned char * dest_fin, unsigned char decal);

/*===============================================================================================
== Ecriture des donnes dcompresse
=================================================================================================
== data : adresse des donnes  dcompresser
== longueur : longueur  dcompresser
== data_dest : adresse de dcompression de donnes
== arbre : arbre de Huffmann
== decal : dcalage (en bit) du dbut (+1)
== racine : emplacement de la racine dans l'arbre
=================================================================================================
== renvoie l'adresse de fin des donnes dcompresses
===============================================================================================*/

extern unsigned char * ecriture_decomp(unsigned char * data, unsigned short longueur, unsigned char * data_dest,
																ARBRE * arbre, unsigned char decal, unsigned char racine);
																