// C Header File
// Created 18/03/2003; 19:39:03

#define _GENERIC_ARCHIVE
#define NO_CALC_DETECT
#include <tigcclib.h>         // Include All Header Files

/* pb:
0: aucun
1: mem
2: can't add dest var
3: var src existe pas
4: can't rearchive
*/

#define COMP_NO_ERR           0
#define COMP_ERR_MEM         -1
#define COMP_ERR_CANT_ADD    -2
#define COMP_ERR_NO_SRC_VAR  -3
#define COMP_ERR_NOT_A_COMP  -4
#define COMP_ERR_WRONG_TYPE  -5
#define COMP_ERR_CANT_COMP   -6
#define COMP_ERR_CANT_REARCH  1

typedef struct {
		unsigned char caract_droit;  //branche droite : 0
		unsigned char caract_gauche;  //branche gauche : 1
		unsigned char noeud_droit:1, noeud_gauche:1;  //dit si caractere ou noeud
		unsigned char noeud_pere;  //numro du noeud suprieur
} ARBRE;


typedef struct {
		unsigned short freq;
		unsigned char noeud;  //1 ou 0
		unsigned char caract;
} NOEUD;

//conversion de type
extern unsigned char tab_typ2[15];
extern unsigned char conv_type(unsigned char type);
unsigned short get_type(SYM_ENTRY * SymPtr);
unsigned short get_type_txt(SYM_ENTRY * SymPtr);

//var
extern SYM_ENTRY * creation_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, HANDLE h, char * pb);

//stat
extern unsigned char creation_stat(unsigned short stat[256], unsigned char * data, unsigned short longueur);
extern void tri_stat(unsigned short stat[256], NOEUD noeud[256]);

//pr-calculs
extern void creation_arbre(NOEUD noeud[256], ARBRE * arbre, unsigned char nL);
extern void comp_arbre(ARBRE * arbre, unsigned char * dest, unsigned char nL);
extern unsigned long eval_long(ARBRE * arbre, unsigned short stat[256]);
extern void decomp_arbre(unsigned char * data, ARBRE * arbre, unsigned char nL);

//ecriture
extern unsigned char * ecriture_decomp(unsigned char * data, unsigned short longueur, unsigned char * data_dest,
																ARBRE * arbre, unsigned char decal, unsigned char racine);
extern unsigned char ecriture_comp(unsigned char * data, unsigned short longueur, ARBRE * arbre, unsigned char * dest_fin, unsigned char decal);

//caculs
extern HANDLE mk_zip(unsigned char * data, unsigned short longueur, unsigned char type, BOOL temp, char * pb);
extern HANDLE mk_dzip(unsigned char * data, unsigned short longueur, const char * str_tag, unsigned char tag_length, char * pb);
extern HANDLE mk_komp(unsigned char *data, unsigned short longueur, unsigned char type, BOOL temp, char * pb);
extern HANDLE mk_dkomp(unsigned char * data, unsigned short longueur, const char * str_tag, unsigned char tag_length, char * pb);

//zip
#define zip_data_temp(data,longueur,pb)							mk_zip(data,15,longueur,TRUE,pb)
extern SYM_ENTRY * zip_data_var(unsigned char *data, unsigned short longueur, const char * nom_var, char * pb);
extern HANDLE 		 zip_sym_temp(SYM_ENTRY * sym_var_src, char * pb);
extern SYM_ENTRY * zip_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb);
#define zip_var_temp(nom_var,pb)											zip_sym_temp(DerefSym(SymFind(SYMSTR(nom_var))),pb)
#define zip_var_var(nom_var_src,nom_var_dest,pb)			zip_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),nom_var_dest,pb)

//dzip
#define dzip_data_temp(data,longueur,pb)							mk_dzip(data,longueur,NULL,0,pb)
extern SYM_ENTRY * dzip_data_var(unsigned char * data, unsigned short longueur, const char * nom_var_dest, const char * str_tag, unsigned char tag_length, char * pb);
extern HANDLE 		 dzip_sym_temp(SYM_ENTRY * sym_var_src, char * pb);
extern SYM_ENTRY * dzip_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb);
#define dzip_var_temp(nom_var,pb)										dzip_sym_temp(DerefSym(SymFind(SYMSTR(nom_var))),pb)
#define dzip_var_var(nom_var_src,nom_var_dest,pb)		dzip_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),nom_var_dest,pb)

//komp
#define komp_data_temp(data,longueur,pb)						mk_komp(data,longueur,TRUE,pb)
extern SYM_ENTRY * komp_data_var(unsigned char *data, unsigned short longueur, const char * nom_var, char * pb);
extern HANDLE 		 komp_sym_temp(SYM_ENTRY * sym_var_src, char * pb);
extern SYM_ENTRY * komp_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb);
#define komp_var_temp(nom_var,pb)										komp_sym_temp(DerefSym(SymFind(SYMSTR(nom_var))),pb)
#define komp_var_var(nom_var_src,nom_var_dest,pb)		komp_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),nom_var_dest,pb)

//dkomp
#define dkomp_data_temp(data,longueur,pb)						mk_dkomp(data,longueur,NULL,0,pb)
extern SYM_ENTRY * dkomp_data_var(unsigned char * data, unsigned short longueur, const char * nom_var_dest, const char * str_tag, unsigned char tag_length, char * pb);
extern HANDLE 		 dkomp_sym_temp(SYM_ENTRY * sym_var_src, char * pb);
extern SYM_ENTRY * dkomp_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb);
#define dkomp_var_temp(nom_var,pb)										dkomp_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),pb)
#define dkomp_var_var(nom_var_src,nom_var_dest,pb)		dkomp_sym_temp(DerefSym(SymFind(SYMSTR(nom_var)),nom_var_dest,pb)

