// C Source File
// Created 14/04/2003; 20:58:56

#define _GENERIC_ARCHIVE
#define NO_CALC_DETECT
#include "complib_types.h"
#include "huffman.h"
#include "utils.h"
#include <tigcclib.h>         // Include All Header Files

/*===============================================================================================
== Compression de l'arbre pour ziplib
=================================================================================================
== arbre : arbre  compresser
== dest : adresse o l'on doit compresser l'arbre
== nL : nombre de caractres diffrents
===============================================================================================*/

void comp_arbre(ARBRE * arbre, unsigned char * dest, unsigned char nL) {
		unsigned char br_gauche[256];  //branche  gauche  aller visiter plus tard
		unsigned char no_brg=0;        //no de la dernire branche gauche  aller visiter
		unsigned char decal=0;
		unsigned char * dest2=dest+nL;  //adresse du dbut de l'arbre et fin du tableau des caractres
		unsigned char no=nL-2;
		
		*dest2=0x01;  //on suppose qu'il y a au moins un noeud
droit:
		if ((decal++)==7){
				decal=0;
				++dest2;
		}

		if (arbre[no].noeud_droit) { //noeud  droite
				br_gauche[no_brg++]=no;  //il va falloir visiter  gauche plus tard
				*dest2|=(1<<decal);      //noeud => 1
				no=arbre[no].caract_droit;    //on va  droite
				goto droit;
		}
		*(dest++)=arbre[no].caract_droit;  //caractre  droite

gauche:  //on regarde  gauche
		if ((decal++)==7) {
				decal=0;
				++dest2;
		}

		if (arbre[no].noeud_gauche) { //noeud  gauche
				*dest2|=(1<<decal);
				no=arbre[no].caract_gauche;   //on regarde au noeud de gauche
				goto droit;  //puis on regarde  droite
		}
		*(dest++)=arbre[no].caract_gauche;  //caractre  gauche

		if ((no_brg--)==0)  //il n'y  plus branche  gauche  visiter
				return;
		no=br_gauche[no_brg];  //on regarde cette branche  gauche

		goto gauche;
}


/*===============================================================================================
== Dcompression de l'arbre pour ziplib
=================================================================================================
== data : adresse du dbut de l'arbre compress
== arbre : arbre  regnrer
== nL : nombre de caractres diffrents
===============================================================================================*/

void decomp_arbre (unsigned char * data, ARBRE * arbre, unsigned char nL) {
		unsigned char * data2=data+nL;  //adresse du dbut de l'arbre lui-mme et de fin du tableau de caractres
		char decal=0;
		unsigned char no=0;     //no de noeud
		unsigned char no_w=0;  //no du dernier noeud
		unsigned char br_gauche[256];
		unsigned char no_brg=0;

droite:

		if ((decal++)==7) {
				decal=0;
				data2++;
		}

		if ((*data2)&(1<<decal)) {  //1 => noeud
				arbre[no].caract_droit=++no_w;  //on lit ce noeud au suivant
				arbre[no].noeud_droit=1;
				br_gauche[no_brg++]=no;  //il faudra aller voir la branche de gauche
				no=no_w;
				goto droite;  //au suivant
		}
		arbre[no].caract_droit=*(data++);  //pas de noeud  droite

gauche:  //qu'est-ce qu'il y a  gauche
		if ((decal++)==7) {
				decal=0;
				data2++;
		}

		if ((*data2)&(1<<decal)) {  //noeud
				arbre[no].caract_gauche=++no_w;  //on lie ce noeud au suivant
				arbre[no].noeud_gauche=1;
				no=no_w;
				goto droite;  //on regarde  droite
		}
		arbre[no].caract_gauche=*(data++);  //pas de noeud

		if ((no_brg--)==0)  //plus de branche  gauche  voir ?
				return;
		no=br_gauche[no_brg];  //branche de gauche suivante

		goto gauche;
}


/*===============================================================================================
== Compresion ziplib
=================================================================================================
== data : adresse des donnes  compresser
== longueur : longueur des donnes  compresser
== type : type selon filelib
== temp : boolen faux si on va crer une variable (ajout du tag "ZIP")
                  vrai si c'est temporaire
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes compresses
===============================================================================================*/

HANDLE mk_zip(unsigned char * data, unsigned short longueur, unsigned char type, BOOL temp, char * pb) {

		unsigned short * stat;
		unsigned char *  dest;
		unsigned char *  dest2;
		unsigned char    decal;
		
		NOEUD * noeud;
		ARBRE * arbre;
		
		unsigned char nL;
		unsigned long long2;
		unsigned long l;
		unsigned short long_comp;


		HANDLE h;

		*pb=COMP_NO_ERR;

		stat=malloc(256*sizeof(unsigned short));
		if (stat==NULL) {
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}
		noeud=malloc(256*sizeof(NOEUD));
		if (noeud==NULL) {
				free(stat);
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}

		nL=creation_stat(stat,data,longueur);

		tri_stat(stat,noeud);

		arbre=malloc(nL*sizeof(ARBRE));
		if (arbre==NULL) {
				free(stat);
				free(noeud);
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}
		memset(arbre,0,nL*sizeof(ARBRE));
		creation_arbre(noeud,arbre,nL);
		free(noeud);

		long2=eval_long(arbre,stat);
		free(stat);

		l=((unsigned long)nL<<1)-1+long2;
		decal=l&0x07;
		l>>=3;
		long_comp=l+10+nL+(decal!=0)+2+6*(!temp);

		if (long_comp>=longueur) {
				*pb=COMP_ERR_CANT_COMP;
				free(arbre);
				return H_NULL;
		}
		
		h=HeapAlloc(long_comp+2);
		if (h==H_NULL) {
				free(arbre);
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}
		dest=HLock(h);
		if (dest==NULL) {
				HeapFree(h);
				free(arbre);
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}
		
		memset(dest+14,0,2*nL);

		dest2=dest+long_comp+2-6*(!temp);
		if (ecriture_comp(data,longueur,arbre,dest2-1,decal-1)==0) {
				HeapFree(h);
				free(arbre);
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}

		comp_arbre(arbre,dest+14,nL);

		free(arbre);

		if (!temp) {
				memcpy(dest2,"\0ZIP\0",5);
				*(unsigned char *)(dest2+5)=OTH_TAG;
		}

		dest2=dest;
		*(unsigned short*)dest2=long_comp;  //longueur du zip
		dest2+=2;
		*dest2=type;  //faut mettre le type
		*(++dest2)=0xFF;
		*(unsigned short *)(++dest2)=1;  //nb de fichier compresss
		*(unsigned short *)(dest2+=2)=nL;   //nLenght (nb de caractres diffrents)
		*(unsigned short *)(dest2+=2)=(((unsigned short)nL-1)>>2)+10+nL; //position de l'adresse de dpart
		*(unsigned short *)(dest2+=2)=(((unsigned short)nL<<1)-1)&0x07;  //position du bit de dpart
		*(unsigned short *)(dest2+=2)=longueur;  //longueur du fichier extrait

		if (HeapUnlock(h)==H_NULL) {
				HeapFree(h);
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}

		return h;
}


/*===============================================================================================
== Compression ziplib de donne dans une variable
=================================================================================================
== data : pointeur des donnes  dcompresser
== longueur : longueur des donnes  dcompresser
== nom_var_dest : nom de la variable dans laquelle on doit dcompresser
== str_tag : tag  ajouter  la fin
== tag_length : longueur du tag (ne se termine pas par 0! impossible d'utiliser strlen)
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le pointeur Sym de la variable cre
===============================================================================================*/

SYM_ENTRY * zip_data_var(unsigned char *data, unsigned short longueur, const char * nom_var, char * pb) {

		HANDLE h;

		h=mk_zip(data,longueur,15,FALSE,pb);
		if (h==H_NULL)
				return NULL;

		return creation_var(NULL,nom_var,h,pb);
}


/*===============================================================================================
== Compression ziplib d'une variable dans un handle temporaire
=================================================================================================
== sym_var_src : pointeur sym de la var  compresser
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes compresses
===============================================================================================*/

HANDLE zip_sym_temp(SYM_ENTRY * sym_var_src, char * pb) {
		unsigned char * data;
		unsigned char type;
		unsigned short longueur=0;
		HANDLE h;
		HANDLE h_var;
		
		if (sym_var_src==NULL) {
				*pb=COMP_ERR_NO_SRC_VAR;
				return H_NULL;
		}

		h_var=sym_var_src->handle;
		data=HLock(h_var);
		if (data==NULL) {
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}

		longueur=*(unsigned short *)data;

		type=conv_type(data[longueur+1]);

		h=mk_zip(data+2,type,longueur,TRUE,pb);

		HeapUnlock(h_var);

		return h;
}


/*===============================================================================================
== Compression ziplib d'une variable dans une autre variable
=================================================================================================
== sym_var_src : pointeur sym de la var  compresser
== nom_var_dest : nom de la variable dans laquelle on compresse
									si vaut NULL, compresse dans la variable de dpart
== str_tag : tag  ajouter  la fin
== tag_length : longueur du tag (ne se termine pas par 0! impossible d'utiliser strlen)
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie pointeur Sym de la nouvelle variable
===============================================================================================*/

SYM_ENTRY * zip_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char *pb) {
		unsigned char * data;
		unsigned char type;
		unsigned short longueur;
		HANDLE h;
		HANDLE h_var;
		
		if (sym_var_src==NULL) {
				*pb=COMP_ERR_NO_SRC_VAR;
				return NULL;
		}

		h_var=sym_var_src->handle;
		data=HLock(h_var);
		if (data==NULL) {
				*pb=COMP_ERR_MEM;
				return NULL;
		}
		longueur=*(unsigned short *)data;
		
		type=conv_type(data[longueur+1]);

		h=mk_zip(data+2,longueur,type,FALSE,pb);
		if (h==H_NULL) {
				*pb=COMP_ERR_MEM;
				return NULL;
		}
		HeapUnlock(h_var);
		return creation_var(sym_var_src,nom_var_dest,h,pb);
}


/*===============================================================================================
== Dcompression ziplib
=================================================================================================
== data : adresse des donnes  dcompresser
== longueur : longueur des donnes  dcompresser
== str_tag : tag  ajouter  la fin
== tag_length : longueur du tag (ne se termine pas par 0! impossible d'utiliser strlen)
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes dcompresses
===============================================================================================*/

HANDLE mk_dzip(unsigned char * data, unsigned short longueur, const char * str_tag, unsigned char tag_length, char * pb) {
		ARBRE * arbre;
		unsigned char * data_dest;
		unsigned char * data2;
		unsigned char decal;
		unsigned short nb_fichier;
		unsigned short nL;
		unsigned short pos_add_dep;
		unsigned short long_fichier;
		HANDLE h;

		*pb=COMP_NO_ERR; //no pb

		data++;
		if (*(data++)!=0xFF && strcmp(&(data[longueur-3]),"ZIP")==0) {//ce n'est pas un zip
				*pb=COMP_ERR_NOT_A_COMP;
				return H_NULL;
		}

		data2=data;
		nb_fichier=*(unsigned short *)data2;
		nL=*(unsigned short *)(data2+=2);
		pos_add_dep=*(unsigned short *)(data2+=2);
		decal=*(unsigned short *)(data2+=2);
		long_fichier=*(unsigned short *)(data2+=2);

		h=HeapAlloc(long_fichier+2+tag_length);
		if (h==H_NULL) {
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}
		data_dest=HLock(h);
		if (data_dest==NULL) {
				HeapFree(h);
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}
		
		arbre=(ARBRE *)malloc(nL*sizeof(ARBRE));
		if (arbre==NULL) {
				HeapFree(h);
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}
		memset(arbre,0,nL*sizeof(ARBRE));

		decomp_arbre(data2+2,arbre,nL);

		data=ecriture_decomp(data+pos_add_dep,long_fichier,data_dest+2,arbre,decal,0);

		*(unsigned short *)data_dest=long_fichier;
		
		for (nL=0;nL<tag_length;nL++) //recopie du tag personnalis pour la dcompression data -> var
				*(data++)=*(str_tag++);
				
		if (HeapUnlock(h)==H_NULL) {
				HeapFree(h);
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}

		return h;
}

/*===============================================================================================
== Dcompression ziplib de donne dans une variable
=================================================================================================
== data : pointeur des donnes  dcompresser
== longueur : longueur des donnes  dcompresser
== nom_var_dest : nom de la variable dans laquelle on doit dcompresser
== str_tag : tag  ajouter  la fin
== tag_length : longueur du tag (ne se termine pas par 0! impossible d'utiliser strlen)
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le pointeur Sym de la variable cre
===============================================================================================*/

SYM_ENTRY * dzip_data_var(unsigned char * data, unsigned short longueur, const char * nom_var_dest,
													const char * str_tag, unsigned char tag_length, char * pb) {

		HANDLE h;
		
		if ( (*data>=15 && (str_tag==NULL || tag_length==0) ) || nom_var_dest==NULL) {
				*pb=COMP_ERR_WRONG_TYPE;
				return NULL;  //il faut imprativement donner un type  la variable et un nom
		}
		if (*data<15 && (str_tag==NULL || tag_length==0) ) {
				str_tag=&(tab_typ2[*data]);
				tag_length=1;
		}
		
		h=mk_dzip(data,longueur,str_tag,tag_length,pb);
		if (h==H_NULL)
				return NULL;
				
		return creation_var(NULL,nom_var_dest,h,pb);

}


/*===============================================================================================
== Dcompression ziplib d'une variable dans un handle temporaire
=================================================================================================
== sym_var_src : pointeur sym de la var  dcompresser
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le handle des donnes dcompresses
===============================================================================================*/

HANDLE dzip_sym_temp(SYM_ENTRY * sym_var_src, char * pb) {
		unsigned char * data;
		unsigned short longueur;
		HANDLE h;
		HANDLE h_var;

		if (sym_var_src==NULL) {
				*pb=COMP_ERR_NO_SRC_VAR;
				return H_NULL;
		}
				
		h_var=sym_var_src->handle;
		data=HLock(h_var);
		if (data==NULL) {
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}
		longueur=*(unsigned short *)data;

		h=mk_dzip(data+2,longueur,NULL,0,pb);

		HeapUnlock(h_var);

		return h;
}

/*===============================================================================================
== Dcompression ziplib d'une variable dans une variable
=================================================================================================
== sym_var_src : pointeur sym de la var  dcompresser
== nom_var_dest : nom de la variable dans laquelle on dcompresse
									si vaut NULL, dcompresse dans la variable de dpart
== pb : pointeur pour renvoyer le code du probleme, si probleme il y a eu
=================================================================================================
== renvoie le pointeur Sym de la nouvelle variable
===============================================================================================*/

SYM_ENTRY * dzip_sym_var(SYM_ENTRY * sym_var_src, const char * nom_var_dest, char * pb) {

		unsigned char * data;
		unsigned short longueur;
		HANDLE h;
		HANDLE h_var;
		
		if (sym_var_src==NULL) {
				*pb=COMP_ERR_NO_SRC_VAR;
				return H_NULL;
		}

		h_var=sym_var_src->handle;
		data=HLock(h_var);
		if (data==NULL) {
				*pb=COMP_ERR_MEM;
				return H_NULL;
		}
		longueur=*(unsigned short *)data;
		
		h=mk_dzip(data+2,longueur,NULL,0,pb);
		if (h==H_NULL)
				return NULL;
		HeapUnlock(h_var);
		return creation_var(sym_var_src,nom_var_dest,h,pb);
}

